{****************************************************************************
 *           } Unit UCountry;{ (c) 1999 Michal Cihar                        *
 ****************************************************************************
 * CONTACT                                                                  *
 *  WWW: http://miso.fd.cz                                                  *
 *  MAIL: ciharm@fel.cvut.cz                                                *
 ****************************************************************************
 This unit makes your program to be coutry adaptive - get DOS coutry or set
 it by your program. Provides functions to return date and time strings
 that are formated according to unit country settings. Unit country settings
 are accesible via record - you can also modify this, if you need.
 Also country specific UpCase functions are available (for Char, String and
 (if STRINGS defined) pChar).
 If CONTRY.SYS and NLSFUNC are installed you can also change DOS country code.
 NOTES: This unit by default reads info from DOS so this information depends
        on DOS manufacturer and version, but the country numbers should be
        correspondent to names in standart datafile for this unit, but
        country info changes from version to version so be carreful! Some
        "default" settings are included - names DefaultCOD (COD - 3char
        country code) - those are values returned by MS-DOS 6.22. For Czech
        Republic also for other encoding with different time separator (':'
        instead of '.') are available in constants CZEInfoEncoding (Encoding:
        Latin, ASCII or Kamenicky).
        Function SetDOSCountry calls DOS function to set country and updates
        unit CoutryInfo record if this function is supported (normally
        CONTRY.SYS and NLSFUNC must be installed). If it isn't supported,
        unit CountryInfo is not changed and function returns non-zero value
        (extended DOS error code).
        In CountryInfo record there is pointer to upcase procedure - don't
        use this normally in Pascal. This needs in AL character (>=$80=128)
        to be uppercased. By some DOS is returned incorrect value. Differs
        more version to version than contry to country.
        During inicialization of ContryInfo (by InitUnit, SetDOSCountry)
        is needed a bit extra memory (cca 100 bytes) if it isn't free program
        is terminated!}
{{$DEFINE STRINGS} {enable this for pchar routines}
interface
const UnitID='UCountry';
      UnitCopyright='1999 Michal Cihar';
      UnitVersion='1.0';
      UnitRelease='1.2.1999';
      {filename used to get country names:}
      UnitDataFile:string='UCOUNTRY.DAT';
      {coutry number constants follows (only the most used):}
      CountryUSA=001;  {USA or no COUNTRY.SYS installed}
      CountryCZE=042;  {Czech republic/Czechoslovakia}
      CountryGRB=044;  {Great Britain}
      CountryAUT=043;  {Austia}
      CountryGER=049;  {Germany}
      CountrySVK=421;  {Slovakia}
      CountryCZA=$ffd;{Czech republic with ASCII encoding - NOT DOS
                        number used only by this unit}
      CountryCZK=$ffe;{Czech republic with Kamenicky encoding - NOT DOS
                        number used only by this unit}
      {string returned by GetCountryName, when name not found in data file}
      CountryNameUnknown:string='Coutry ID not found';
      {"zero" before first number in date/time:}
      LeadingZero:char='0';
      {what is placed after time if 12-hour clock:}
      AMPM:array[0..1] of string[5]=('a','p');

type tCountryInfo = record
                     DateFormat:word;
                     {DateFormat:
                      0 = USA     mm dd yy
                      1 = Europe  dd mm yy
                      2 = Japan   yy mm dd}
                     {next arrays - nul terminated strings}
                     CurrencySymbol:array[1..5] of char;
                     ThousandsSeparator:array[1..2] of char;
                     DecimalSeparator:array[1..2] of char;
                     DateSeparator:array[1..2] of char;
                     TimeSeparator:array[1..2] of char;
                     CurrencyFormat:byte;
                     {CurrencyFormat:
                      bit 2 = set if currency symbol replaces decimal point
                      bit 1 = number of spaces between value and currency symbol
                      bit 0 = 0 if currency symbol precedes value
                              1 if currency symbol follows value}
                     CurrencyDecimals:byte;
                     TimeFormat:byte;
                     {TimeFormat:
                      bit 0 = 0 if 12-hour clock
                              1 if 24-hour clock}
                     UpCaseRoutine:pointer;
                     {I can't recomend you to use this - sometime unsupported!
                      FAR CALL, AL = character to map to upper case [>= 80h]}
                     {next array - nul terminated strings}
                     ListSeparator:array[1..2] of char;
                     Reserved:array[1..10] of byte;
                    end;
     tCountryRec = record
                     Number:word;
                     Name:string[255];
                     ShortName:string[3];
                    end;
     {follows tCcountryInfo defaults (these are values that returns
     MS-DOS 6.22):}
const DefaultUSA:tCountryInfo=
                     (DateFormat:0;
                     CurrencySymbol:('$',#0,#0,#0,#0);
                     ThousandsSeparator:(',',#0);
                     DecimalSeparator:('.',#0);
                     DateSeparator:('-',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:0;
                     CurrencyDecimals:2;
                     TimeFormat:0;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      DefaultCZE:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('K','',#0,#0,#0);
                     ThousandsSeparator:(' ',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:('.',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      DefaultGRB:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('',#0,#0,#0,#0);
                     ThousandsSeparator:(',',#0);
                     DecimalSeparator:('.',#0);
                     DateSeparator:('/',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:0;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      DefaultGER:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('D','M',#0,#0,#0);
                     ThousandsSeparator:('.',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(';',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      DefaultAUT:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('S',#0,#0,#0,#0);
                     ThousandsSeparator:('.',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:2;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(';',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      DefaultSVK:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('S','k',#0,#0,#0);
                     ThousandsSeparator:(' ',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:('.',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(';',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
     {follows CZE, SVK tCcountryInfo defaults (by me):}
      CZEInfoLatin:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('K','',#0,#0,#0);
                     ThousandsSeparator:(' ',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      CZEInfoASCII:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('K','c',#0,#0,#0);
                     ThousandsSeparator:(' ',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));
      CZEInfoKamenicky:tCountryInfo=
                     (DateFormat:1;
                     CurrencySymbol:('K','',#0,#0,#0);
                     ThousandsSeparator:(' ',#0);
                     DecimalSeparator:(',',#0);
                     DateSeparator:('.',#0);
                     TimeSeparator:(':',#0);
                     CurrencyFormat:3;
                     CurrencyDecimals:2;
                     TimeFormat:1;
                     UpCaseRoutine:nil;
                     ListSeparator:(',',#0);
                     Reserved:(0,0,0,0,0,0,0,0,0,0));

{upper case conversion table for Kamenicky encoding}
const UpCaseTableKam:array[#0..#255] of char=
      (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,
       #10,#11,#12,#13,#14,#15,#16,#17,#18,#19,
       #20,#21,#22,#23,#24,#25,#26,#27,#28,#29,
       #30,#31,#32,#33,#34,#35,#36,#37,#38,#39,
       #40,#41,#42,#43,#44,#45,#46,#47,#48,#49,
       #50,#51,#52,#53,#54,#55,#56,#57,#58,#59,
       #60,#61,#62,#63,#64,#65,#66,#67,#68,#69,
       #70,#71,#72,#73,#74,#75,#76,#77,#78,#79,
       #80,#81,#82,#83,#84,#85,#86,#87,#88,#89,
       #90,#91,#92,#93,#94,#95,#96,'A','B','C',
       'D','E','F','G','H','I','J','K','L','M',
       'N','O','P','Q','R','S','T','U','V','W',
       'X','Y','Z',#123,#124,#125,#126,#127,#128,#154,
       #144,#133,#142,#133,#134,#128,#137,#137,#138,#139,
       #156,#138,#142,#143,#144,#146,#146,#167,#153,#149,
       #166,#151,#157,#153,#154,#155,#156,#157,#158,#134,
       #143,#141,#149,#151,#165,#165,#166,#167,#155,#158,
       #171,#171,#172,#173,#174,#175,#176,#177,#178,#179,
       #180,#181,#182,#183,#184,#185,#186,#187,#188,#189,
       #190,#191,#192,#193,#194,#195,#196,#197,#198,#199,
       #200,#201,#202,#203,#204,#205,#206,#207,#208,#209,
       #210,#211,#212,#213,#214,#215,#216,#217,#218,#219,
       #220,#221,#222,#223,#224,#225,#226,#227,#228,#229,
       #230,#231,#232,#233,#234,#235,#236,#237,#238,#239,
       #240,#241,#242,#243,#244,#245,#246,#247,#248,#249,
       #250,#251,#252,#253,#254,#255);


var {information about country}
    CountryInfo:tCountryInfo;
    {country number}
    CountryNumber:word;
    {code page used}
    CodePage:word;

{initializes unit variables - called on unit start}
procedure InitUnit;
{sets unit variables to user defined}
procedure ForceCountry(const NewCountryNumber,NewCodePage:word;const NewCountryInfo:tCountryInfo);
{sets DOS country to NewCountryNumber, if function is not supported returns
 nonzero value}
function SetDOSCountry(const NewCountryNumber:word):word;
{gets packed date and time (see help PackTime or DateTime)}
function GetDateTime:longint;
{returns date and time strings according to country settings, l is packed
 date and time information (can be obtained by GetDateTime, PackTime or
 GetFTime). If seconds flag is true then seconds are included in time,
 otherwise they are not.}
procedure DateTime2Str(const l:longint;const Seconds:boolean;var date,time:string);
{returns country name - reads info from data file with name UnitDataFile
 so keep in this variable actual filename}
function GetCountryName(const number:word;var Shortname:string):string;
function UpCaseChar(const char2upcase:char):char;
function UpCaseString(const String2upcase:string):string;
{$IFDEF STRINGS}
function UpCasePChar(const String2upcase:pchar):pchar;
{$ENDIF}

implementation
uses dos
{$IFDEF STRINGS}
     ,strings
{$ENDIF}
     ;

type pCountryInfo2 = ^tCountryInfo2;
     tCountryInfo2 = record
                     infoID:byte;
                     size:word;
                     CountryID:word;
                     CodePage:word;
                     CountryInfo:tCountryInfo;
                   end;
const size=sizeof(tCountryInfo2);
var CountryInfo2:pCountryInfo2;

procedure initunit;
begin;
new(CountryInfo2);
if countryinfo2=nil then
begin;
  writeln('************************************************');
  writeln('* ERROR: Not enough memory to get country info *');
  writeln('************************************************');
  writeln('Unit ',UnitID,' needs minimally ',size+20,' bytes of free memory.');
  writeln('Program terminated by unit ',UnitId,' version ',UnitVersion,' (c) ',UnitCopyright);
  halt(1);
end;
asm
les di, CountryInfo2
mov ah, 065h
mov al, 01h
mov bx, 0ffffh
mov dx, 0ffffh
mov cx, size
int 021h
end;
countryinfo:=CountryInfo2^.countryinfo;
countrynumber:=CountryInfo2^.countryID;
codepage:=CountryInfo2^.codepage;
dispose(CountryInfo2);
end;

function SetDOSCountry(const NewCountryNumber:word):word;assembler;
asm
mov ah, 038h
mov dx, 0ffffh
mov bx, NewCountryNumber
cmp bh, 0
je @less
mov al, 0ffh
jmp @call
@less:
mov al, bl
@call:
int 021h
jc @end  {if carry is set function is not supported, so no changes}
call initunit
xor ax,ax {return 0}
@end:
end;

procedure ForceCountry(const NewCountryNumber,NewCodePage:word;const NewCountryInfo:tCountryInfo);
begin;
CountryInfo:=NewCountryInfo;
CountryNumber:=NewCountryNumber;
CodePage:=NewCodePage;
end;

function GetDateTime:longint;
var dt:datetime;
    dow:word;
    dattim:longint;
    Sec100: Word;
begin;
with dt do
begin;
getdate(Year, Month, Day, DOW);
gettime( Hour, Min, Sec, Sec100);
end;
packtime(DT,dattim);
GetDateTime:=dattim;
end;

procedure DateTime2Str(const l:longint;const Seconds:boolean;var date,time:string);
var dt:datetime;
function Word2Str2(const W:word):string;
var s:string;
begin;
str(W,s);
if W<10 then Word2Str2:='0'+s
        else Word2Str2:=s;
end;
function Word2Str1(const W:word):string;
var s:string;
begin;
str(W,s);
if W<10 then Word2Str1:=leadingzero+s
        else Word2Str1:=s;
end;
begin;
unpacktime(l,dt);
with dt do
begin;
case CountryInfo.DateFormat of
                    0:Date:= Word2Str1(Month)+CountryInfo.DateSeparator[1]+
                             Word2Str2(Day)+CountryInfo.DateSeparator[1]+
                             Word2Str1(Year);
                    1:Date:= Word2Str1(Day)+CountryInfo.DateSeparator[1]+
                             Word2Str2(Month)+CountryInfo.DateSeparator[1]+
                             Word2Str1(Year);
                    2:Date:= Word2Str1(Year)+CountryInfo.DateSeparator[1]+
                             Word2Str2(Month)+CountryInfo.DateSeparator[1]+
                             Word2Str2(Day);
                    end;
if seconds then
case (CountryInfo.TimeFormat and 1) of
                    0:Time:=Word2Str1(Hour mod 12)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Min)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Sec)+AMPM[Hour div 12];
                    1:Time:=Word2Str1(Hour)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Min)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Sec);
                    end
else
case (CountryInfo.TimeFormat and 1) of
                    0:Time:=Word2Str2(Hour mod 12)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Min)+AMPM[Hour div 12];
                    1:Time:=Word2Str2(Hour)+CountryInfo.TimeSeparator[1]+
                            Word2Str2(Min);
                    end;
end;
end;

function GetCountryName(const number:word;var Shortname:string):string;
var f:file of tCountryRec;
    rec:tCountryRec;
begin;
Shortname:='';
if (unitdatafile='') then begin;getcountryname:=countrynameunknown;exit;end;
{$I-}
assign(f,unitdatafile);
reset(f);
{$I+}
if (IOResult<>0) then begin;getcountryname:=countrynameunknown;exit;end;
repeat
read(f,rec);
until (rec.number=number)or(eof(f));
close(f);
if rec.number=number then begin;
                            getcountryname:=rec.name;
                            Shortname:=rec.shortname;
                          end
                     else getcountryname:=countrynameunknown;
end;

function UpCaseCharKam(const char2upcase:char):char;
begin;
UpCaseCharKam:=UpCaseTableKam[char2upcase];
end;


function UpCaseCharInt(const char2upcase:char):char;assembler;
asm
mov ax, 06520h
mov dl, char2upcase
int 021h
mov al, dl
end;

function UpCaseChar(const char2upcase:char):char;
begin;
case countryNumber of $ffe:UpCaseChar:=UpCaseCharKam(char2upcase);
                      $ffd:UpCaseChar:=UpCase(char2upcase);
                      else UpCaseChar:=UpCaseCharInt(char2upcase);
                      end;
end;

function UpCaseStringKam(const String2upcase:String):String;
var i:byte;
    s:string;
begin;
s:='';
if String2upcase<>'' then
begin;
for i:=1 to length(String2upcase) do
s:=s+UpCaseTableKam[String2upcase[i]];
end;
upcasestringkam:=s;
end;

function UpCaseStringAsc(const String2upcase:String):String;
var i:byte;
    s:string;
begin;
s:='';
if String2upcase<>'' then
begin;
for i:=1 to length(String2upcase) do
s:=s+UpCase(String2upcase[i]);
end;
upcasestringAsc:=s;
end;

function UpCaseStringInt(const String2upcase:string):string;
var s:^string;
begin;
new(s);
s^:=string2upcase;
asm
push ds
mov ax, 06521h
lds dx, s
mov bx, dx
mov cx, ds:[bx]
inc dx
int 021h
pop ds
end;
upcasestringint:=s^;
end;

function UpCaseString(const String2upcase:string):string;
begin;
case countryNumber of $ffe:UpCaseString:=UpCaseStringKam(String2upcase);
                      $ffd:UpCaseString:=UpCaseStringAsc(String2upcase);
                      else UpCaseString:=UpCaseStringInt(String2upcase);
                      end;
end;


{$IFDEF STRINGS}
function UpCasePChar(const String2upcase:pchar):pchar;
var s:pchar;
begin;
s:=strnew(string2upcase);
asm
push ds
mov ax, 06521h
lds dx, s
int 021h
pop ds
end;
upcasePCHAR:=s;
end;
{$ENDIF}

begin;
initunit;
end.